      SUBROUTINE RSPLT(X,Y,ER,NPT,ITYPE,IER,NTX,NTY,NTEX)
      COMMON/SPLTC/VARS(32)
      COMMON/COORD/X0,Y0,M
      CHARACTER*(*) NTEX
      CHARACTER*(*) NTX,NTY
      DIMENSION X(*),Y(*),ER(*)
C**
C** SUBROUTINE PARAMETERS
C**
C** X=ABSCISSA POINTS
C** Y=ORDINATE POINTS
C** ER=ERROR VALUE
C** NPT=NUMBER OF POINTS
C** ITYPE=0 DRAW ONLY AXES AND TEXT. LIMITS OF SCALE IN X(1),X(2) AND
C**         Y(1),Y(2)
C**      >0 DRAW AXES AND TEXT. LIMITS OF SCALE CALCULATED FROM X AND Y
C**         PLOT SYMBOLS.
C**      <0 SUPERIMPOSE PLOT.
C**      =IABS(1) PLOT A CENTRED POINT
C**      =IABS(2)  "     CROSS
C**      =IABS(3)  "     ASTERISK
C**      =IABS(4)  "     CIRCLE
C**      =IABS(5)  "     DIAGONAL CROSS
C**      =IABS(6)  "     SQUARE
C**      =IABS(7)  "     TRIANGLE
C**      =IABS(8)  "     CIRCLE WITH CROSS
C**      =IABS(9)  "     POINT IN CIRCLE
C**      =IABS(10) "     INVOLUTE SQUARE
C**      =IABS(11) "     DIAMOND
C**   =IABS(100) "    CONTINUOUS LINE
C**   =IABS(200) "    DASHED LINE
C**   =IABS(300) "    DOT-DASHED LINE
C**   =IABS(400) "    DOTTED LINE
C**   =IABS(500) "    DASH-DOT-DOT-DOT LINE
C** IER=0 NO ERROR BARS
C**    =1 ERROR BARS
C** NTX=TEXT FOR X-AXIS (20 CHARACTERS)
C** NTY=TEXT FOR Y-AXIS (20 CHARACTERS)
C** NTEX=TEXT GENERAL (40 CHARACTERS)
C**
C** COMMON SPLTC
C**
C** VARS(1)=IN CURSOR MODE AFTER PLOT
C** VARS(2)=in START OF X-AXIS IN NDC UNITS
C** VARS(3)=in START OF Y-AXIS IN NDC UNITS
C** VARS(4)=out MINIMUM X VALUE IN USER UNITS
C** VARS(5)=out MAXIMUM X   "   "    "    "
C** VARS(6)=out MINIMUM Y   "   "    "    "
C** VARS(7)=out MAXIMUM Y   "   "    "    "
C** VARS(8)=out NO. OF NDC UNITS PER USER UNIT ON X AXIS
C** VARS(9)=out  "     "     "    "    "   "   "  Y AXIS
C** VARS(13)=IN END OF X-AXIS IN SCREEN UNITS
C** VARS(14)=IN END OF Y-AXIS IN SCREEN UNITS
C**
C** EXTENSION:
C** VARS(15)= IF SET NO CALL INITT TO INITIALIZE SCREEN
C** VARS(16)= IF SET TO 1 NO FRAME GRID DISPLAYED
C**      = IF SET TO 2 ALSO NO AXES VALUES AND TITLE
C** common is initialised in TDLMR
C**IF SUPERIMPOSING PLOT
      IF(ITYPE.LT.0)GOTO 100
      CALL ERASE
C** IF MIN. AND MAX. GIVEN
      XMIN=X(1)
      XMAX=X(2)
      YMIN=Y(1)
      YMAX=Y(2)
      IF(ITYPE.EQ.0.AND.NPT.LE.2)GOTO 21
C** CALCULATE MIN. AND MAX.
      XMIN=1E20
      XMAX=-1E20
      YMIN=1E20
      YMAX=-1E20
      DO 20 I=1,NPT
      XMIN=AMIN1(XMIN,X(I))
      XMAX=AMAX1(XMAX,X(I))
      YMIN=AMIN1(YMIN,Y(I))
      YMAX=AMAX1(YMAX,Y(I))
   20 CONTINUE
   21 CONTINUE
C** RETURN X AND Y MIN. AND MAX.
      VARS(4)=XMIN
      VARS(5)=XMAX
      VARS(6)=YMIN
      VARS(7)=YMAX
C** FIND SCALE OF PLOT
      CALL TDLMR(XMIN,XMAX,800.,XMINR,XMAXR,DSX,EXPX,0)
      CALL TDLMR(YMIN,YMAX,500.,YMINR,YMAXR,DSY,EXPY,0)
C** CALCULATE NUMBER OF SCREEN UNITS PER USER UNIT
      DRX=1./(XMAX-XMIN)
      DRY=1./(YMAX-YMIN)
      VARS(8)=DRX
      VARS(9)=DRY
C**DRAW SCREEN
c***** place logo...
      if(vars(2).eq.0..and.vars(11).eq.0.) then
        call pgvport(0.858,.968,0.0,0.105)
        call pgwindow(0.,1.,0.,1.)
        call pgwnad(0.,1.,0.,1.)
        call pubess(.95,1)
C***** REDEFINE LOCAL DRAW WINDOW
        CALL PGSVP(0.15,0.85,0.1,0.8)
      else 
        call pgsvp(vars(2),vars(11),vars(3),vars(12))
      endif
C***** N.D.C'S
      CALL PGSWIN(XMIN,XMAX,YMIN,YMAX)
C***** WORLD COORDS
C***** CURRENT WINDOW FROM HERE TO PGUNSA
      CALL PGBOX('ABCTNS',0.,4,'ABCTNSV',0.,4)
      IAX=0
C***** SET SCALE LIMITS AND DRAW BOX AND TICK LABELS
      IF (VARS(16).EQ.2) GO TO 90 ! also no axes values and title
      CALL PGBBUF
      CALL PGMTXT('T',1.5,0.5,0.5,NTEX)
      CALL PGMTXT('B',3.2,0.5,0.5,NTX)
      CALL PGMTXT('L',5.0,0.5,0.5,NTY)
      CALL PGEBUF
C**OUTPUT ON SCREEN X VALUES
C**OUTPUT TITLE AND SCALE FOR X AXIS
C**OUTPUT TITLE AND SCALE FOR Y AXIS
C** IF PLOTTING AXES ONLY
   90 IF(ITYPE.EQ.0)GOTO 350
C** IF PLOTTING LINES IT >=100
  100 IT=IABS(ITYPE)
      IF(IT.GE.100)GOTO 120
C**PLOT SYMBOLS
      CALL PGBBUF
      CALL PGPOINT(NPT,X,Y,IT)
      CALL PGEBUF
C**IF ERROR BARS
      IF(IER.EQ.0) GO TO 110
      DO 105 I=1,NPT
      CALL PGERRY(1,X(I),Y(I)+ER(I),Y(I)-ER(I),0.)
105   CONTINUE
110   CONTINUE
      IF(VARS(1).EQ.0) GO TO 350
      GOTO 300
C**PLOT LINES
120   LINES=IT/100
C****** 5 LINE STYLES POSSIBLE...
C***** save current style
      CALL PGQLS(IOLDS)
      CALL PGSLS(LINES)
      CALL PGBBUF
      CALL PGLINE(NPT,X,Y)
      CALL PGEBUF
      CALL PGSLS(IOLDS)
C***** AND RESTORE...
      IF(VARS(1).EQ.0) GO TO 350
C** IF CURSOR MODE
300   IF(VARS(1).NE.0.)CALL POSCUR
350   RETURN
      END
