      SUBROUTINE RSIO(IER,MM,IRUN,IRUNX,NSET,TITLE,PAR,DAT,ERD,PN)
C***** READS AND WRITES DATA OF IXxIY SPECTRA
C
C     RAW DATA (EXTENSION 0) IS FOUND FROM RAW DATABASE
C     OTHER DATA (EXTENSION > 0) IS FOUND IN ASCII FILES
C
C
C     IER       ERROR RETURN (NON-ZERO) IF DATA NOT FOUND
C     MM        R to read, W to write
C     IRUN      RUN NUMBER SOUGHT
C     IRUNX     EXTENSION RUN NUMBER
C     NSET      FILE DESCRIPTION
C       NSET(1)         NUMBER OF lines (80 chars) in extra text (OR 0)
C       NSET(2)         NPAR NUMBER OF PARAMETERS IN PAR (32=RGIO)
C       NSET(3) NPARX   NUMBER OF PARAMETERS IN PARX (OR 0)
C       NSET(4) NX      NUMBER OF ROW DATA
C       NSET(5) NY      NUMBER OF COLUMN DATA
C       NSET(6)         NERROR  SET TO 1 IF ERROR RECORDS ARE PRESENT
C     TITLE     TITLE ARRAY (SET LENGTH 50  (short 1:20 long 21-50)
C     PAR       PARA ARRAY AS IN RSV (MAX LENGTH 24 IF NPAR=0)
C     DAT       DATA ARRAY NXxNY REALS
C     ERD       ERROR ARRAY (IF NSET(6) NOT 0)
C     PN        PROGRAM NAME (SET AS 'ABCD', CHARACTER VARIABLE)
C
C               COMMON/LIMINP/ININP LIMITS READING ALLOWS SKIPPING DATA..
C***** R.E. GHOSH, ILL GRENOBLE, MAY 1988, Unix March 1995
C
C
C     note RSIO titles (/RSIOD/PARTIT) are distict from those 
c     in RGIO (/RGIOD/PARTIT
      PARAMETER (NXY=102400)
      DIMENSION DAT(NXY),ERD(NXY)
      DIMENSION PAR(40),NSET(6)
      COMMON/MAXARR/LTITL,LPAR,LPARX,LDATX
      COMMON/PRNAM/PNAME
      COMMON/VERSION/VERP,VERS
      COMMON/TTYIO/INPT,KOUT,IERR
      COMMON/RSUNIT/NUNIT
      COMMON/RSX/NOMEXP,DDATE
      COMMON/RSXT/TITLEL
      COMMON/RSIOP/PARR(128)
      common/RGIOP/PARX(20)
      COMMON/RGIOC/XTXT(10)
      COMMON/RSIOD/PARTIT(40)
      COMMON/RGIOX/NTXT,NPARX
      COMMON/RGINST/INST
      COMMON/MANAME/MINAME
      common/liminp/ininp
      CHARACTER*30 PARTIT
      CHARACTER*4 ERRINP,PNAME,PN,INST
      CHARACTER*50 TITLE
      CHARACTER*1 TITLEX(512),MM
      CHARACTER*512 TITLEL
      CHARACTER NOMEXP*10,DDATE*20,XTXT*80,MINAME*30
      EQUIVALENCE(IDD,DDD),(TITLEX(1),TITLEL)
      SAVE IONCE
      DATA IONCE/0/,LTITLE/50/
      IF(KOUT.LE.0) KOUT=6
      PNAME=PN
      IER=0
C***** RESET ERROR FLAG LOCALLY
      IF(NUNIT.EQ.0) NUNIT=31
C***** VERSION - Nov 2006  (REG)
      VERS=5.3
      IF(IRUNX.GE.0.OR.IRUNX.LE.999) GO TO 2
      WRITE(KOUT,3)
3     FORMAT(' ? RSIO-ERROR EXTENSION  0<=>999')
      IER=-1
      RETURN
2     IRUNXT=IRUNX
      IF(IONCE.NE.0) GO TO 10
      IONCE=1
      MINAME=' '
      CALL USERLOG(PNAME,'sasuse.use')
C***** IMPOSE BOUNDS ON READ-IN ROUTINES TO PROTECT CALLING PROGGRAMS
      IF(LTITL.EQ.0) LTITL=512
      IF(LPAR.EQ.0) LPAR=128
      IF(LDATX.EQ.0) LDATX=NXY
C***** TEST FOR ERRORS REQUIRED FROM OUTPUT ROUTINES
      IERRS=0
C VMS     IST=SYS$TRNLOG('SAS$ERROR',LENS,%DESCR(ERRINP),,,)
C VMS     IF(.NOT.IST) GO TO 10
      CALL GETENV('SAS_ERROR',ERRINP)
      IF(INDEX(ERRINP,' ').EQ.1) GO TO 10
C***** NOT SET - DEFAULT TO WRITING FULL ERROR OUTPUT
      IF(ERRINP.NE.'NONE') GO TO 10
      IERRS=1
10    CONTINUE
      IF(MM.EQ.'R'.OR.MM.EQ.'r') GO TO 40
C***** READ
      IF(MM.EQ.'W'.or.MM.eq.'w') GO TO 100
C***** WRITE
      STOP 'RSio - NOT READ/WRITE OPTION'
C***** NO OUTPUT DIRECTORY (MM=2) IN THIS ASCII VERSION
40    DO 401 I=1,LTITLE
      TITLEX(I)=' '
401   CONTINUE
      DO 402 I=1,LPAR
402   PARR(I)=0.
      DO 403 I=1,LPARX
403   PARX(I)=0.
      DO 404 I=1,LDATX
      DAT(I)=0.
      ERD(I)=0.
404   CONTINUE
C****** ALL OUTPUT INITIALISED  
      IF(IRUNX.NE.0) GO TO 80
C***** AND THEN READ FROM ASCII DATA SOURCE....
C VMS      CALL SASINV(IRUN,IER,MEDVAR,P1,P2,DAT)
      CALL SASAS(IER,IRUN,INST,NOMEXP,DDATE,NTITLx,TITLEX,
     1NPARR,PARR,NDATR,DAT)
C
C***** WARNING - 32 BIT REALS AND 32 BIT INTEGERS ARE ASSUMED HERE
C***** BECAUSE SASAS RETURNS INTEGERS - CONVERTED TO REALS LATER
C***** USING EQUIVALENC OF IDD,DDD
C
C***** SASAS DOES NOT RETURN ANY PARX OR XTXT FIELDS

      IF(IER.NE.0) RETURN
C***** NOTE DAT IS ACTUALLY RETURNED AS INTEGER*4 VALUES
C***** NOW FILL IN ABSENT FIELDS
47    NSET(1)=0
C***** SHOULD DO CONVERSION A5=>A4 SOMETIME...AND CHECK MAX RANGE (NTITL)
      TITLE=' '
      TITLE(1:20)=TITLEL(61:80)
C***** SUBTITLE
C***** NOW IF TITLE STARTS WITH USELESS NOMEXP REPEATED...
      IF(TITLEL(1:10).EQ.NOMEXP) TITLE(21:50)=TITLEL(11:40)
      IF(TITLEL(1:10).NE.NOMEXP) TITLE(21:50)=TITLEL(1:30)
C***** MAIN TITLE
41    CONTINUE
      NSET(2)=32
      DO 42 I=1,NSET(2)
42    PAR(I)=0
      CALL REPAR(PAR,PARR)     
      NSET(3)=0
C***** NO PARX IN RAW DATA
      NSET(4)=64
C***** NX
      NSET(5)=64
C***** NY
      IF(NDATR.EQ.16384) NSET(4)=128
      IF(NDATR.EQ.16384) NSET(5)=128
      IF(NDATR.EQ.NXY) NSET(4)=320
      IF(NDATR.EQ.NXY) NSET(5)=320
C***** D16
      IF(NDATR.EQ.1024) NSET(4)=64
      IF(NDATR.EQ.1024) NSET(5)=16
C***** IF NO DATA HAS BEEN READ (DUE TO LIMINP BEING SET>0)
      IF(NDATR.EQ.0) NSET(4)=0
      IF(NDATR.EQ.0) NSET(5)=0
      NSET(6)=1
      IF(NDATR.EQ.0) NSET(6)=0
C***** FLAGS THAT ERRORS ARE GOING TO BE RETURNED
      NTOT=NSET(4)*NSET(5)
      DO 44 I=1,NTOT
      DDD=DAT(I)
      DAT(I)=IDD
C***** CONVERT FROM INTEGER*4 TO REALS
44    ERD(I)=SQRT(DAT(I))
      NTXT=0
      NPARX=0
      RETURN
C***** READ WHOLE OF DATA UP TO THAT ALLOWED BY LIMINP
80    CALL DNIN(IER,IRUN,IRUNX,NSET,TITLE,PAR,DAT,ERD)
      RETURN
C***** END OF READ-IN SECTION
100   CONTINUE
C***** WRITE OUTPUT
      IF(IRUNX.EQ.0) STOP ' ? RSIO-IRUNX=0 ON OUTPUT'
      CALL DNOUT(IER,IRUN,IRUNX,NSET,TITLE,PAR,DAT,ERD)
      RETURN
      END
      SUBROUTINE DNIN(IER,IRUN,IRUNX,NSET,TITLE,PAR,DAT,ERD)
      PARAMETER (NXY=102400)
      COMMON/MAXARR/LTITL,LPAR,LPARX,LDATX
      COMMON/RSUNIT/NUNIT
      DIMENSION DAT(NXY),ERD(NXY),NSET(6),PAR(40)
      COMMON/TTYIO/INP,KOUT,IERR
      COMMON/RGIOP/PARX(20)
      COMMON/RGIOC/XTXT(10)
      COMMON/RGIOX/NTXT,NPARX
      COMMON/RSIOD/PARTIT(40)
      COMMON/RGINST/INST
      COMMON/MANAME/MINAME
      COMMON/MSKFLC/FNAMM
      COMMON/MSKFLL/LENF
      COMMON/NEWMASK/GRDD
      common/liminp/ininp
      CHARACTER*80 XTXT
      CHARACTER*11 FNAME
      CHARACTER*16 ERRMSG,debug
      CHARACTER*4 KEYS,KEYX,INST
      CHARACTER*50 TITLE
      CHARACTER*30 PARTIT
      CHARACTER MINAME*30,ONAME*4,ODATE*20,GRDD*8,FNAMM*30
      SAVE IVERS,KEYX
      DATA KEYX/'ILL '/
      DATA IVERS/2/
      call getenv('SAS_DEBUG',debug)
c***** get length
      ideb=index(debug,' ')
c***** debug is all blank if not set, hence ideb=1 for no debug
      WRITE(FNAME,10) IRUN,IRUNX
10    FORMAT('t',I6.6,'.',I3.3)
C***** ALWAYS LOOK FOR VERSION ;1 on VMS
      ERRMSG='File not found'
      OPEN(UNIT=NUNIT,FILE=FNAME,ACCESS='SEQUENTIAL',ERR=990,
     1FORM='FORMATTED',STATUS='OLD')
      ERRMSG='Title record'
      if(ideb.ne.1) write(6,97) errmsg
       TITLE=' '
      INST='    '
      READ(NUNIT,20,ERR=99,END=99) TITLE
20    FORMAT(A)
25    CONTINUE
C***** READ KEYS
      ERRMSG=' Key record'
      if(ideb.ne.1) write(6,97) errmsg
      READ(NUNIT,230,ERR=99,END=99) KEYS,INST(1:3)
230   FORMAT(A4,6X,A3)
      IF(KEYS.NE.KEYX) GO TO 99
      ERRMSG='Run/ext...'
      if(ideb.ne.1) write(6,97) errmsg
      READ(NUNIT,240,ERR=99,END=99) IRUNN,IRUNNX,ND1,ND2,NSKIPF,
     1NPDF
      IF(IRUNN.NE.IRUN.OR.IRUNNX.NE.IRUNX) GO TO 99
      ERRMSG='Internal structure'
      if(ideb.ne.1) write(6,97) errmsg
      NSET(4)=ND1
      NSET(5)=ND2
      NTOT=NSET(4)*NSET(5)
      IF(LDATX.LE.0) LDATX=NTOT
      ERRMSG='Too much data'
      if(ideb.ne.1) write(6,97) errmsg
      IF(NTOT.GT.LDATX) GO TO 99
C***** PICK UP TEXT
c***** now ivers, ntxt,npar,nparx
      READ(NUNIT,240,ERR=99,END=99) IVVERS,NTX,NPARR,NPARRX,NPDFX,IERRS
240   FORMAT(8I10)
      ERRMSG='Data version>prg'
      if(ideb.ne.1) write(6,97) errmsg
      IF(IVVERS.GT.IVERS) go to 99
C******  CREATION PROGRAM AND DATE AND OLD MASK
      ERRMSG='Internal date'
      if(ideb.ne.1) write(6,97) errmsg
      MINAME=' '
      READ(NUNIT,251,ERR=99,END=99) ONAME,ODATE,MINAME
251   FORMAT(A4,2X,A20,4X,A30)
C***** Don't overwrite newer mask
      IF(GRDD.NE.'NEW MASK') FNAMM=MINAME(7:29)
      IF(FNAMM.NE.' '.AND.GRDD.NE.'NEW MASK') GRDD='OLD MASK'
      
250   FORMAT(1X)
      NSET(1)=NTX
      NSET(2)=NPARR
      NSET(3)=NPARRX
      NSET(6)=IERRS
      IF(NSET(1).LE.0) GO TO 28
      ERRMSG='Extra text'
      IF(NTX.GT.LTITL) GO TO 99
      DO 26 I=1,NSET(1)
      READ(NUNIT,30,ERR=99,END=99) XTXT(I)
26    CONTINUE
30    FORMAT(A80)
C***** NOW RSV TYPE PARAMETERS
28    ERRMSG='Parameters'
      if(ideb.ne.1) write(6,97) errmsg
      IF(NPARR.GT.LPAR) GO TO 99    
      IF(NSET(2).LE.0) GO TO 45
      DO I=1,NSET(2)
      NNN=i
      READ(NUNIT,40,ERR=95,END=99) PAR(I),PARTIT(I)
      END DO
40    FORMAT(F10.4,3x,A30)
45    CONTINUE
C***** NOW SPARE PARAMETERS USE A4 FORMAT
      ERRMSG='Extra parameters'
      if(ideb.ne.1) write(6,97) errmsg
      IF(NPARRX.GT.LPARX) GO TO 99
      IF(NSET(3).GT.0)
     1READ(NUNIT,30,ERR=99,END=99) (PARX(I),I=1,NSET(3))
      IF(ININP.le.0) GO TO 60
C***** INPUT AVOIDS READING DATA - ONLY TEXT AND PARAS RETURNED
      NSET(4)=0
      NSET(5)=0
      NSET(6)=0
      RETURN
60    ERRMSG='READING DATA'
      if(ideb.ne.1) write(6,97) errmsg
      IF(NTOT.GT.0)
     1READ(NUNIT,61,ERR=99,END=99) (DAT(I),I=1,NTOT)
61    FORMAT(8(1x,E10.3))
      ERRMSG='READING ERRORS'
      if(ideb.ne.1) write(6,97) errmsg
 97    format(' DNIN - debug reached test for ',a)
      IF(NTOT.GT.0.AND.NSET(6).GT.0)
     1READ(NUNIT,61,ERR=99,END=99) (ERD(I),I=1,NTOT)
24    CLOSE(UNIT=NUNIT)
      RETURN
95    CONTINUE
      WRITE(KOUT,96) NNN,PARTIT(NNN)
96    FORMAT(' Error reading parameter ',i3,2x,a)
99    CLOSE(UNIT=NUNIT)
      WRITE(KOUT,98) ERRMSG,FNAME
98    FORMAT(' ERROR ',A/' Currently reading : ',a)
      IER=-1
      RETURN
990   WRITE(KOUT,989) IRUN,IRUNX
989   FORMAT(' No data found for run ',i6,' ext. ',i4)
      IER=-1
      CLOSE(NUNIT)
      RETURN
      END
      SUBROUTINE DNOUT(IER,IRUN,IRUNX,NSET,TITLE,PAR,DAT,ERD)
C     OUTPUTS 2D DATA IN ASCII
C
C***** R.E. GHOSH I.L.L.  JANUARY 1986, MAY 1988, JAN 1989, MARCH 95
      PARAMETER (NXY=102400)
      DIMENSION DAT(NXY),ERD(NXY),PAR(40),PARR(40)
      COMMON/TTYIO/INP,KOUT,IERR
      COMMON/RSUNIT/NUNIT
      COMMON/RSERR/IERRS
      COMMON/RGIOP/PARX(20)
      COMMON/RGIOC/XTXT(10)
      COMMON/RGIOX/NTXT,NPARX
      COMMON/RGINST/INST
      COMMON/RSIOD/PARTIT
      COMMON/MANAME/MINAME
      COMMON/MSKFLC/FNAMM
      COMMON/MSKFLL/LENF
      COMMON/NEWMASK/GRDD
      COMMON/PRNAM/PNAM
      CHARACTER*80 XTXT
      CHARACTER*11 FNAME
      CHARACTER*4 INST,PNAM
      CHARACTER*20 DTIME
      CHARACTER*16 ERRMSG
      CHARACTER*50 TITLE
      CHARACTER*30 PARTIT(40)
      CHARACTER EXTCMD*100,EXTENV*80
      CHARACTER*30 MINAME,FNAMM
      CHARACTER*8 GRDD
      LOGICAL EX
      INTEGER NSET(6)
      SAVE IVERS
      DATA IVERS/2/
      IF(IERRS.EQ.1) NSET(6)=0
C***** DON'T OUTPUT ERRORS WHEN LOGICAL SAS$ERROR IS SET TO NONE
C***** CHECK FOR EXISTING FILE FIRST
      IROUND=0
      ERRMSG='Opening file'
2     WRITE(FNAME,10) IRUN,IRUNX
10    FORMAT('t',I6.6,'.',I3.3)
      INQUIRE(FILE=FNAME,EXIST=EX)
      IF(.NOT.EX) GO TO 5
      IRUNX=IRUNX+1
      IROUND=IROUND+1
      IF(IROUND.GT.999) GO TO 99
C***** REMOVE A POTENTIAL INFINITE LOOP 999 IS THE MAXIMUM EXTENSION
      IF(IRUNX.GT.999) IRUNX=1
      GO TO 2
5     OPEN(UNIT=NUNIT,FILE=FNAME,
     1ACCESS='SEQUENTIAL',STATUS='NEW',FORM='FORMATTED')
C***** FILE OPENED SUCCESSFULLY, ALTERNATIVELY, INCREASE EXT NUMBER AND RETRY
C ***** NO FILE FOUND
      NTX=NSET(1)
      NPAR=NSET(2)
      NPARX=NSET(3)
      ND1=NSET(4)
      ND2=NSET(5)
      NPDF=0
      NPARXL=(NPARX+4)/5
      NSKIP=5+NTX+NPAR+NPARXL
      NSKIP1=NSKIP-2
      ERRMSG='Run record'
      WRITE(NUNIT,120,ERR=99) TITLE,NSKIP
120   FORMAT(A,I5,' lines+ I(x,y)//errI(x,y)')
c                  1234567890123456789012345
      ERRMSG='Key record'
      WRITE(NUNIT,130,ERR=99) INST(1:3)
130   FORMAT('ILL  SANS ',a3,'   ')
      NTX=NSET(1)
      NPAR=NSET(2)
      NPARX=NSET(3)
      IERRRS=NSET(6)
C***** The Hutchings effect...
C      IERRS=NSET(6)
      NPDFX=0
      WRITE(NUNIT,150) IRUN,IRUNX,ND1,ND2,NSKIP1,NPDF
      WRITE(NUNIT,150) IVERS,NTX,NPAR,NPARX,NPDFX,IERRRS
150   FORMAT(8I10)
      CALL DAYT(DTIME)
      IF(GRDD.EQ.'NEW MASK') MINAME='MASK: '//FNAMM(1:24)
      WRITE(NUNIT,140) PNAM,DTIME,MINAME
140   FORMAT(A4,2X,A20,4X,A30)
C***** WAS  1X
20    FORMAT(10I8)
      IF(NSET(1).LE.0) GO TO 35
      DO 31 I=1,NSET(1)
      WRITE(NUNIT,30,ERR=99) XTXT(I)
31    CONTINUE
30    FORMAT(A80)
35    IF(NSET(2).GT.0) THEN
c***** check values are printable
      DO 170 I=1,NSET(2)
      PARR(I)=0.
      IF(I.EQ.9.OR.I.EQ.10) go to 170
      PARR(I)=PAR(I)
      IF(PAR(I).GT. 99999.) PARR(I)=99999.99
      IF(PAR(I).LT.-99999.) PARR(I)=-9999.99
170   CONTINUE
      PARR(9)=PAR(9)
      PARR(10)=PAR(10)
      IF(PARR(9).LT.0) PARR(9)=0.
      IF(PARR(10).LT.-9999999.) PARR(10)=0  
      IF(PARR(9). GT. 9999999.) PARR(9)= 9999999.
      IF(PARR(10).GT.9999999.)  PARR(10)=9999999.
      WRITE(NUNIT,40,ERR=99) (PARR(I),PARTIT(I),I=1,NSET(2))
40    FORMAT(8(F10.4,' ! ',A/),2(F10.0,' ! ',A/),(F10.4,' ! ',A))
      END IF
      IF(NSET(3).GT.0)
     1WRITE(NUNIT,50,ERR=99) (PARX(I),I=1,NSET(3))
50    FORMAT(5E16.8)
      NTOT=NSET(4)*NSET(5)
      IF(NSET(5).GT.0)
     1WRITE(NUNIT,60,ERR=99) (DAT(I),I=1,NTOT)
60    FORMAT(8(1x,1PE10.3))
      IF(NSET(6).GT.0)
     1WRITE(NUNIT,60,ERR=99) (ERD(I),I=1,NTOT)
      CLOSE(UNIT=NUNIT)
c***** do we have an external command..
      CALL GETENV('SAS_EXTRA_T',EXTENV)
      CALL TRIMMD(EXTENV,IEXCMD)
      EXTCMD=' '
      IF(IEXCMD.NE.0) EXTCMD=EXTENV(1:IEXCMD+1)//FNAME
      IF(IEXCMD.NE.0) CALL SYSTEM(EXTCMD)
      RETURN
99    WRITE(KOUT,98) errmsg,fname
98    FORMAT(' ERROR ',a/' WRITING', a)
      CLOSE(UNIT=NUNIT)
      IER=-1
      RETURN
      END
      BLOCK DATA RSAB
      COMMON/MAXARR/LTITL,LPAR,LPARX,LDATX
c***** initialsised in sasas.f
      COMMON/PRNAME/PNAM
      COMMON/TTYIO/INPT,KOUT,IERR
      COMMON/RSUNIT/NUNIT
      COMMON/RSIOD/PARTIT(40)
      CHARACTER PARTIT*30,PNAM*4
      SAVE
      DATA INPT/5/,KOUT/6/,NUNIT/33/
      DATA PNAM/'    '/
      DATA PARTIT/
     1'Theta-0 Detector offset angle ',
     1'X0 cms Beam centre            ',
     1'Y0 cms Beam centre            ',
     1'Delta-R cms regrouping step   ',
     1'SD m Sample-detector distance ',
     1'Angstroms incident wavelength ',
     1'm collimation distance        ',
     1'concentration                 ',
     1'ISUM central window sum       ',
     1'flux monitor counts           ',
     1'degrees detector sector width ',
     1'degrees sector orientation    ',
     1'% FWHM_wavelength spread      ',
     1'mm source slit width x        ',
     1'mm source slit height y       ',
     1'mm sample width x             ',
     1'mm sample height y            ',
     1'mm detector x pixel size      ',
     1'mm detector y pixel size      ',
     1'degrees sample normal/beam    ',
     1'K sample temperature          ',
     1'sample transmission           ',
     1'mm sample thickness           ',
     1'counting time secs            ',
     1'reserved                      ',
     1'reserved                      ',
     1'reserved                      ',
     1'reserved                      ',
     1'reserved                      ',
     1'reserved                      ',
     1'reserved                      ',
     1'reserved                      ',
     18*'                              '/
      END
