      subroutine rawinl(ier,numor,inst,nomexp,ddate,nt,text,np1,
     1par1,np2,par2,np3,par3,nip,ipar,nd,nsp,idon)
c
c for IN5 July 1998
c
c   Run   Format............ from  record      1
c  1445   80A   156I   512A   384F   128F   128F   128I   +  146 x (  512I  )    c
c     reading standard TOF ascii files
c     ier             integer      out  0 ok, else -1
c     numor           integer      in   1<=numor<=999999
c     inst            character*4  out  ints field in file
c     nomexp          character*10 out  nomexp in file
c     ddate           character*20 out  data and time of recording
c     nt              integer      out  number of text (a1)
c     text            character*1  out  text array
c     np1              integer      out  number of real parameters1
c     par1             real         out  real parameters1
c     np2              integer      out  number of real parameters2
c     par2             real         out  real parameters2
c     np3              integer      out  number of real parameters3
c     par3             real         out  real parameters3
c     nip              integer      out  number of integer parameters
c     ipar             integer      out  integer parameters
c     nd              integer      out  number of integers in spectrum
c     nsp             integer      out  total no of data
c     idon            integer      out  spectrum
c environment variables
c  INL_INSTRUMENT     instrument name 4 characters
c  INL_DATA_PATH      directory for raw data
c  INL_DEBUG    flag to print debugging information
c     R. E. Ghosh  August 1998   ron@ill.fr
c
c  the commons:
c  /maxtof/ ntitl,npar,nparx,ndx  512,128,20,16384 respectively
c           protect programs from excessive input. These stored 
c           defaults may be overwritten by calling programs
c  /tofofc/ nunit  file input unit is set to 31 by default
c
c  /lmminp/ ininp  is set to -1 by default. If positive then only
c           that number of data fields are read-in (now there are 5) 
c     History of overflows - continued
C*****  SANS Data Storage - Program MTD  (R. Ghosh 1981-89)
C
C       and now a bit of history:
C       IB(249) defined in documentation should be 1 for 16bit, 3 for 32bit
C       data storage. (ILL-82GH05G, 89GH03T)
C       IB(253) used to be used for TOF instruments to indicate whether data 
C       were to beconverted to 32 bit before storage on DECsystem10. 
C       When 0 no action was to be taken 
C       (otherwise this indicated the position of the
C       letter K in the internal ASCII format: letter this had to be modified
C       to L and IB(253) reset to 0 signalling transormation to 32bit data.) 
C       On the SANS instruments IB(249) has always been set to 0
C       and IB(253)=200 to show that data are 16 bit, because data were
C       subject to special overflow tretment on the DEC-10.
C       No change was introduced when archiving on the central VAX started.
C       All data on VAX, restored from DEC-10 tapes are restored as 32bits
C       and correctly IB(249) is set to 3, and IB(253) is set to 0,
C       following above definitions.
C       From today (December 7th 1989) the test for SANS data will be on 
C       IB(249). If this is set to 3 then 32bit data is assumed, otherwise
C       16 bits is the default. This accounts satisfactorily for all cases.
C       Perhaps one day the header block on the instruments will be corrected
C       to conform 100% with the documentation!
C
C       March 1995 it has happened! - ib(249) medpar(149) is 1 for 16 bit
C       acquisition
C
C       March 1996 adapted to read in either SANS (D11,D17,D22) or D16 data
      common/maxtof/ntitl,npar,nparx,ndx
      common/tofofc/nunit
      common/sasmed/medpar(156)
      common/lmminp/ininp
      common/devfil/fdev
      common/devfii/lf
      real par1(512),par2(512),par3(512)
      integer ipar(512)
      integer idon(1),iovs(256)
      character*8 rtype
      character inst*4,instx*4,nomexp*10,ddate*20
      character fnum*6,fdev*66,errmsg*16,gdev*60,debug*20
      character*1 text(1)
c****** 
c
cd22:-  For reading 156I, 512A, 128F, 256I(overflows or skip), 16384I
cd16:-               80a, 31I, 50F, 1034I (typically)  
c
c******
      ivers=1
c***** modified for D16  September 1997 (REG)
      inst=' '
      ddate=' '
      nomexp=' '
      np=0
      nt=0
      nd=0
      do 500 i=1,npar
      par1(i)=0.
      par2(i)=0.
      par3(i)=0.
      ipar(i)=0
500   continue
      do 501 i=1,ntitl
      text(i)=' '
501   continue
c***** local reals initialised
       indone=ininp
      if(indone.gt.6) indone=-1
c****** there are 6+ data fields present in current data
      ier=-1
      call getenv('INL_DATA_PATH',gdev)
      call getenv('INL_INSTRUMENT',instx)
      call getenv('INL_DEBUG',debug)
c***** get length
      call trimmd(gdev,lf)
      call toup(instx)
      ideb=index(debug,' ')
c***** debug is all blank if not set, hence ideb=1 for no debug
      fnum=' '
      fdev=' '
      errmsg='numor'
      if(ideb.ne.1) write(6,97) errmsg
 97    format(' RAWINL - debug reached test for ',a)
      if(numor.le.0.or.numor.gt.999999) go to 99
      write(fnum,1) numor
1     format(i6.6)
      errmsg='unit'
      if(nunit.le.0) go to 99
      fdev=gdev(1:lf)//fnum
c***** the device name must include the separator /,\ or :
      lf=lf+7
      errmsg='opening file'
      if(ideb.ne.1) write(6,97) errmsg
      open(unit=nunit,file=fdev,status='old',err=99)
      errmsg='record 1'
      read(nunit,2,err=99,end=99) rtype
2     format(a)
      if(rtype.ne.'RRRRRRRR') go to 99
      errmsg='numor'
      if(ideb.ne.1) write(6,97) errmsg
      read(nunit,3,err=99,end=99) numr,itxt,ivrs
3     format(10i8)
      errmsg='version'
      if(ideb.ne.1) write(6,97) errmsg
      if(ivers.lt.ivrs) go to 99
      if(itxt.gt.0) call skipp(itxt)
      errmsg='header text'
      if(ideb.ne.1) write(6,97) errmsg
      read(nunit,2,err=99,end=99) rtype
      read(nunit,3,err=99,end=99) nchars,itxt
      if(itxt.gt.0) call skipp(itxt)
      read(nunit,5,err=99,end=99) inst,nomexp,ddate
5     format(3a)
      errmsg='inst'
      if(ideb.ne.1) write(6,97) errmsg
      if(inst.ne.instx) go to 99
      call intf(ier,ideb,indone,nt,text,np1,par1,np2,par2,
     1np3,par3,nip,ipar,nd,nsp,idon)
      return
99    write(6,98) errmsg,fdev(1:lf)
98    format(' RAWINL: Error - invalid - ',a,/
     1' Currently reading : ',a)
      close(nunit)
      return
      end
      subroutine intf(ier,ideb,indone,nt,text,np1,par1,
     1np2,par2,np3,par3,nip,ipar,nd,nsp,idon)
c***** reads standard fields expecting:
c       156I, 512A, 128F, 256I(overflows or skip), (4096 or 16384)I:
c
      common/maxtof/ntitl,npar,nparx,ndx
      common/tofofc/nunit
      common/sasmed/medpar(156)
      common/lmminp/ininp
      common/devfil/fdev
      common/devfii/lf
      character fnum*6,fdev*66,errmsg*16,gdev*60,debug*20
      character*1 text(1)
      character*8 rtype
      character*80 txx
      real par1(512),par2(512),par3(512)
      integer ipar(512)
      integer idon(1),iovs(256)
      errmsg='medpar array'
      if(ideb.ne.1) write(6,97) errmsg
97    format(' RAWINL - debug reached test for ',a)
      read(nunit,2,err=99,end=99) rtype
      if(rtype.ne.'IIIIIIII') go to 99
      read(nunit,3,err=99,end=99) ni,itxt
      if(ni.ne.156) go to 99
      if(itxt.gt.0) call skipp(itxt)
      read(nunit,3,err=99,end=99) medpar
3     format(10i8)
      indone=indone-1
      if(indone.eq.0) go to 20
      errmsg='text array'
      if(ideb.ne.1) write(6,97) errmsg
      read(nunit,2,err=99,end=99) rtype
2     format(a)
      if(rtype.ne.'AAAAAAAA') go to 99
      read(nunit,3,err=99,end=99) nt,itxt
      if(itxt.gt.0) call skipp(itxt)
      errmsg='too much text'
      if(ideb.ne.1) write(6,97) errmsg
      if(nt.gt.ntitl) go to 99
      read(nunit,6,err=99,end=99) (text(i),i=1,nt)
6     format(80a1)
      indone=indone-1
      if(indone.eq.0) go to 20
c***** par1
      errmsg='real parameters1'
      if(ideb.ne.1) write(6,97) errmsg
      read(nunit,2,err=99,end=99) rtype
      if(rtype.ne.'FFFFFFFF') go to 99
      read(nunit,3,err=99,end=99) np1,itxt
      if(np1.gt.npar) go to 99
      if(itxt.gt.0) call skipp(itxt)
      read(nunit,7,err=99,end=99) (par1(i),i=1,np1)
7     format(5e16.8)
      indone=indone-1
      if(indone.eq.0) go to 20
c***** par2
      errmsg='real parameters2'
      if(ideb.ne.1) write(6,97) errmsg
      read(nunit,2,err=99,end=99) rtype
      if(rtype.ne.'FFFFFFFF') go to 99
      read(nunit,3,err=99,end=99) np2,itxt
      if(np2.gt.npar) go to 99
      if(itxt.gt.0) call skipp(itxt)
      read(nunit,7,err=99,end=99) (par2(i),i=1,np2)
      indone=indone-1
      if(indone.eq.0) go to 20
c***** par3
      errmsg='real parameters3'
      if(ideb.ne.1) write(6,97) errmsg
      read(nunit,2,err=99,end=99) rtype
      if(rtype.ne.'FFFFFFFF') go to 99
      read(nunit,3,err=99,end=99) np3,itxt
      if(np3.gt.npar) go to 99
      if(itxt.gt.0) call skipp(itxt)
      read(nunit,7,err=99,end=99) (par3(i),i=1,np3)
      indone=indone-1
      if(indone.eq.0) go to 20
      errmsg='intg parameters1'
      if(ideb.ne.1) write(6,97) errmsg
      read(nunit,2,err=99,end=99) rtype
      if(rtype.ne.'IIIIIIII') go to 99
c      read(nunit,666,err=99,end=99) txx
666   format(a)
      read(nunit,3,err=99,end=99) nip,itxt
      if(nip.gt.npar) go to 99
      if(itxt.gt.0) call skipp(itxt)
      read(nunit,3,err=99,end=99) (ipar(i),i=1,nip)
      indone=indone-1
      if(indone.eq.0) go to 20
c***** overflows to be added in - else skip to spectrum....

c***** next field should be SSSS
10    continue
      nsp=0
      indone=indone-1
      if(indone.eq.0) go to 20
c***** skip to SSSS
12    read(nunit,2,err=99,end=99) rtype
      if(rtype.ne.'SSSSSSSS') go to 12
      errmsg='spectrum header'
      if(ideb.ne.1) write(6,97) errmsg
      read(nunit,3,err=99,end=99) ispec,nrest,ntot,nrun,itxt
      if(itxt.gt.0) call skipp(itxt)
c      if(ispec.ne.1) go to 99
c***** should be one spectrum only
      errmsg='spectrum data'
      if(ideb.ne.1) write(6,97) errmsg
      read(nunit,2,err=99,end=99) rtype
      if(rtype.ne.'IIIIIIII') go to 99
      read(nunit,3,err=99,end=99) nd,itxt
      if(itxt.gt.0) call skipp(itxt)
      errmsg='too many data'
      if(ideb.ne.1) write(6,97) errmsg
      if(nsp+nd.gt.ndx) go to 99
      errmsg='counts data'
      read(nunit,3,err=99,end=99) (idon(i),i=1+nsp,nd+nsp)
      nsp=nsp+nd
      if(nrest.eq.0) go to 20
      go to 12

20    close(nunit)
      ier=0
      return
99    write(6,98) errmsg,fdev(1:lf)
98    format(' RAWINL: Error - invalid - ',a,/
     1' Currently reading : ',a)
      close(nunit)
      return
      end
      subroutine skipp(nskip)
      common/tofofc/nunit
      do 1 i=1,nskip
      read(nunit,2)
2     format(1x)
1     continue
      return
      end      
      block data tofofb
      common/maxtof/ntitl,npar,nparx,ndx
      common/tofofc/nunit
      common/lmminp/ininp
      save
      data ntitl/512/,npar/512/,nparx/20/,ndx/262100/
c***** data 512*16*32
      data nunit/34/
      data ininp/-1/
      end
