      SUBROUTINE RGIO(IERR,MM,IRUN,IRUNX,TEXT,PAR,NDATA,Q,S,ES,PNAM)
C***** DISK STORAGE AND RETRIEVAL PROGRAM - SINGLE-USER NO INTERLOCKS
C     IERR      SET TO -1 FOR ERROR
C     MM        READ='R', WRITE='W'
C     IRUN      SPECTRUM NUMBER
C     IRUNX     SPECTRUM EXTENSION NUMBER
C     TEXT      SHORT, TEXT(1:20), AND LONG, TEXT(21:50), TITLES
C     PAR       ARRAY OF SPECTRUM PARAMETERS
C  SANS...      (1-8) THETA0,X0,Y0,DR,SD,WAV,COLL,CONC
C               (9-16)ISUM,MONITOR,SECT,PHI0,WAV%,SOURCEx,SOURCEy,SAMx
C               (17-24) SAMPLE-y,PIXx,PIXy,ANGSAMNOR,TEMP,TRANS,THICK,TIME
C               (25-32) RESERVED FOR ILL
C     NDATA     NUMBER OF DATA IN SPECTRUM (LIMIT LIMDAT)
C     Q,S,ES    SPECTRAL DATA
C     PNAM      NAME OF CALLING PROGRAM
C
c
C     note RSIO titles (/RSIOD/PARTIT) are distict from those 
c     in RGIO (/RGIOD/PARTIT
      INTEGER IERR,IRUN,IRUNX
      REAL PAR(40),Q(180),S(180),ES(180),PARR(40)
      COMMON/VERSION/VERP,VERS
      COMMON/LOGUS/USED,NINUT
      COMMON/RGIOY/NUNIT,INTTY
      COMMON/RGIOC/XTXT(10)
      COMMON/RGIOD/PARTIT(40)
      COMMON/RGIOR/PARTIR(40)
      COMMON/RGIOS/PARTIS(40)
      COMMON/RGIOP/PARX(20)
      COMMON/RGIOX/NTXT,NPARX
      COMMON/RGIOI/XPNAM,DATIM
      COMMON/RGINST/INST
      COMMON/RGIOL/NDIM,LIMDAT,LIMTXT,LIMPX,IONCE
      COMMON/RGPDH/R(10),IC(8)
      COMMON/RGIEX/IEXCMD
      COMMON/RGIEC/EXTENV
      COMMON/MSKFLC/MFNAME
      COMMON/MSKFLL/LENF
      COMMON/NEWMASK/GRDD
      COMMON/MRNAME/MINRME
      LOGICAL EX
      CHARACTER*30 PARTIT,PARTIS,PARTIR
      CHARACTER*16 ERRIN
      CHARACTER XTXT*80, TEXT*(*)
      CHARACTER FNAME*11
      CHARACTER*4 PNAM,XPNAM,KEYR,INST,KEY
      CHARACTER*20 DATIM,ERRMSG
      CHARACTER*50 DEBUG,SASMODE
      CHARACTER EXTCMD*100,EXTENV*80
      CHARACTER*10 DEB,SMOD
      CHARACTER*1 MM
      CHARACTER MFNAME*30,GRDD*8,MINRME*30
      SAVE IVERS,IDEB,IREF
      DATA KEY/'ILL '/,NPDF/0/,DEB/'SAS_DEBUG'/,IVERS/1/
      DATA SMOD/'SAS_MODE'/
      IF(IONCE.NE.0) GO TO 4
      EXTENV=' '
      MINRME=' '
      IEXCMD=0
      CALL GETENV(SMOD,SASMODE)
      CALL GETENV('SAS_EXTRA_G',EXTENV)
      CALL TRIMMD(EXTENV,IEXCMD)
      IREF=INDEX(SASMODE,' ')
C***** SEE IF EXPERIMENT IS IN REFLECTION...IF NOT THEN IREF=1
      DO 1 I=1,40
      IF(IREF.EQ.1) PARTIT(I)=PARTIS(I)
      IF(IREF.NE.1) PARTIT(I)=PARTIR(I)
1     CONTINUE
      CALL GETENV(DEB,DEBUG)
      IDEB=INDEX(DEBUG,' ')
C***** DEBUG IS ALL BLANK IF NOT SET HENCE IDEB=1 FOR NO DEBUG
c      IF(NUNIT.EQ.0) NUNIT=32
      IF(INTTY.EQ.0) INTTY=6
      IF(NDIM.LE.0) NDIM=1
      IF(LIMDAT.LE.0) LIMDAT=180
      IF(LIMTXT.LE.0) LIMTXT=10
      IF(LIMPX.LE.0) LIMPX=20
      IONCE=1
      VERS=2.3
      IF(USED.EQ.0) CALL USERLOG(PNAM,'sasuse.use')
4     IERR=0
C***** OPEN DATASET 
C***** INITIALISE COMMON VARIABLES (SET IONCE TO 0 IF NEC. IN MAIN)
      IF(INTTY.LE.0) INTTY=6
      IERR=-1
      ERRMSG='run or extension'
      IF(IDEB.NE.1) WRITE(6,997) ERRMSG
997   FORMAT(' RGIO - debug reached test for ',a) 
      IF(IRUN.LE.0.OR.IRUNX.LT.0.OR.IRUNX.GT.999) GO TO 999
***** UNIT FOR DATA FILE
2     NINUT=NUNIT
C
      ERRMSG='INPUT OPTION'
      IF(IDEB.NE.1) WRITE(6,997) ERRMSG
      IF(MM.EQ.'R'.OR.MM.EQ.'r') GO TO 10
      IF(MM.EQ.'W'.OR.MM.EQ.'w') GO TO 60
      GO TO 999
C
C***** READING DISK DATA
10    IERR=-1
      WRITE(FNAME,8) IRUN,IRUNX
8     FORMAT('g',I6.6,'.',I3.3)
      IF(IREF.NE.1) FNAME(1:1)='r'
      ERRMSG=' opening file'
      IF(IDEB.NE.1) WRITE(6,997) ERRMSG
      OPEN(UNIT=NUNIT,FILE=FNAME,ACCESS='SEQUENTIAL',ERR=990,
     1FORM='FORMATTED',STATUS='OLD')
      ERRMSG='TITLE RECORD'
      IF(IDEB.NE.1) WRITE(6,997) ERRMSG
      READ(NUNIT,20,ERR=999,END=999) TEXT
20    FORMAT(A)
      ERRMSG=' KEY RECORD'
      READ(NUNIT,120,ERR=999,END=999) KEYR,INST(1:3)
120   FORMAT(A4,6x,A3)
      IF(KEY.NE.KEYR) GO TO 999 
      ERRMSG='RUN/EXT RECORD'
      IF(IDEB.NE.1) WRITE(6,997) ERRMSG
      READ(NUNIT,123,ERR=999,END=999)IRUNN,IRUNNX,NTOTD1,NTOTD2,
     1NSKIP,NPDF 
      IF(IRUNN.NE.IRUN.OR.IRUNNX.NE.IRUNX) GO TO 999
      ERRMSG=' DESCRIPTORS'
      IF(IDEB.NE.1) WRITE(6,997) ERRMSG
      READ(NUNIT,123,ERR=999,END=999) IVVERS,NTXT,NPAR,NPARX,
     1NPDFX,IERRS
123   FORMAT(8I10)
      ERRMSG=' VERSION' 
      IF(IDEB.NE.1) WRITE(6,997) ERRMSG
      IF(IVVERS.GT.IVERS) GO TO 999
C***** A TOTAL OF 80 CHARACTERS - USABLE AS TITLE FOR PDF
C***** READ TITLE RECORD FOR LOG+SHORT TITLE
C     CONTAINS PNAM*4,2X,DATIM*20,2X
      ERRMSG='HISTORY RECORD'
      IF(IDEB.NE.1) WRITE(6,997) ERRMSG
      READ(NUNIT,28,ERR=999,END=999) XPNAM,DATIM,MINRME
28    FORMAT(A4,2X,A20,4X,A30)
      DO 21 I=1,10
21    XTXT(I)=' '
C
C***** READ ANY TEXT FIELD   NTXT LINES
C
      IF(NTXT.LE.0) GO TO 23
      ERRMSG='TOO MUCH EXTRA TEXT'
      IF(IDEB.NE.1) WRITE(6,997) ERRMSG
      IF(NTXT.GT.LIMTXT) GO TO 999
24    DO 26 I=1,NTXT
      ERRIN='EXTRA TEXT'
      IF(IDEB.NE.1) WRITE(6,997) ERRMSG
      READ(NUNIT,27,ERR=999,END=999) XTXT(I)
27    FORMAT(A)
26    CONTINUE
23    CONTINUE
C
C***** READ PARAMETERS
C
      ERRMSG='PARAMETERS'
      IF(IDEB.NE.1) WRITE(6,997) ERRMSG
      IF(NPAR.LE.0) GO TO 999
C***** SHOULD ALWAYS BE PARAS PRESENT
      READ(NUNIT,31,ERR=999,END=999) (PAR(I),PARTIT(I),I=1,NPAR)
31    FORMAT(F10.4,3X,A30)
C
C***** READ EXTRA PARAMETERS
      ERRMSG='TOO MANY EXTRA PARAMETERS'
      IF(IDEB.NE.1) WRITE(6,997) ERRMSG
      IF(NPARX.LE.0) GO TO 40
      IF(NPARX.GT.LIMPX) GO TO 999
      READ(NUNIT,41,ERR=999,END=999) (PARX(I),I=1,NPARX)
41    FORMAT(5E16.8)
40    CONTINUE
      IF(NPDF.LT.3) GO TO 47
C***** DON'T HAVE THESE IN REFLECTION MODE...
C***** PDF SECTION....................................
      ERRMSG='PDF SECTION'
      IF(IDEB.NE.1) WRITE(6,997) ERRMSG
      READ(NUNIT,45,ERR=999,END=999) IC
45    FORMAT(8(I9,1X))
      READ(NUNIT,46,ERR=999,END=999) R
46    FORMAT(5(E14.6,1X))
C***** 3 LINES IN TOTAL
C***** READ DATA
C
47    ERRMSG='TOO MANY S(Q) DATA'
      IF(NDIM.LE.1) NDIM=1
      IF(IDEB.NE.1) WRITE(6,997) ERRMSG
      IF(NTOTD1.GT.LIMDAT) GO TO 999
      ERRMSG='READING S(Q) DATA'
      IF(IDEB.NE.1) WRITE(6,997) ERRMSG
54    DO 56 I=1,NTOTD1
      READ(NUNIT,57,ERR=999,END=999) Q(I),S(I),ES(I)
57    FORMAT(3(1PE14.6,1X))
56    CONTINUE
      NDATA=NTOTD1
      CLOSE(UNIT=NUNIT)
      IERR=0 
      RETURN
C
C	WRITING DATA
C
C***** PICK UP TEXT
C**
C**** WRITING DISK
C**

60    IROUND=0
      ERRMSG='EXTENSIONS 1-999 USED UP'
      IF(IDEB.NE.1) WRITE(6,997) ERRMSG
61    CONTINUE
      IROUND=IROUND+1
      IF(IROUND.GT.1000) GO TO 999
C***** ALL EXTENSIONS USED ALREADY!
      WRITE(FNAME,8) IRUN,IRUNX
      IF(IREF.GT.1) FNAME(1:1)='r'
C***** FIRST FIND NEXT UNIQUE FILE NAME
      INQUIRE(FILE=FNAME,EXIST=EX)
      IF(.NOT.EX) GO TO 63
      IRUNX=IRUNX+1
      IF(IRUNX.GT.999) IRUNX=1
      GO TO 61
C***** CHECK AGAINST SOMEONE FILLING UP ALL 1000?...
63    CONTINUE
      CALL DAYT(DATIM)
C***** CHECK THAT PNAM IS WRITABLE
      XPNAM='NOOP'
      DO 65 I=1,4
      IF(ICHAR(PNAM(I:I)).GE.32.AND.ICHAR(PNAM(I:I)).LE.122)
     1XPNAM(I:I)=PNAM(I:I)
65    CONTINUE   
C***** SET UP REMAINING FIELDS
      NPAR=32
C***** ONLY 32 ARE WRITTEN NOW
      IERRS=1
C***** ERROR OUTPUT FLAG
      IF(NTXT.LT.0) NTXT=0
      IF(NTXT.GT.LIMTXT) NTXT=LIMTXT
      IF(NPARX.LT.0) NPARX=0
      IF(NPARX.GT.LIMPX) NPARX=LIMPX
      LPARX=(NPARX+4)/5
      NTOTD2=1
C***** CALCULATE NUMBER OF LINES TO SKIP TO GET TO Q,S,ES DATA
C***** THERE ARE LPDF LINES OF PDF INFO
      LPDF=3
      IF(IREF.GT.1) LPDF=0
C***** 5 HEADER, NPAR LINES FOR NPAR PAR...
      NSKIP=5+NTXT+NPAR+LPARX+LPDF
      NSKIP1=NSKIP-2
      NPDF=2+NTXT+NPAR+LPARX
      IF(IREF.GT.1) NPDF=0
C***** THIS IS THE NUMBER OF LINES TO BE SKIPPED AFTER KEY
C***** TO GET TO THE INTEGER RECORD OF PDF
      NSPAR=0
C***
C-------PDF PART ALSO CONSIDER...SEEMS TO BE UNNECESSARY...
      DO 69 I=1,8
      IC(I)=0
      R(I)=0.
69    CONTINUE
      R(9)=0.
      R(10)=0.
      IC(1)=NDATA
      IC(8)=6
      R(1)=PAR(8)
      R(2)=PAR(5)*100.
      R(4)=1.0
      R(5)=PAR(6)*0.1
C***** WAVELENGTH IN A=>nm

      R(6)=PAR(21)
C     R(6) TEMP, R10 LAGRANGE MULTIPLIER
C***
      ERRMSG='OPENING OUTPUT'
      IF(IDEB.NE.1) WRITE(6,997) ERRMSG
      OPEN (UNIT=NUNIT,FILE=FNAME,STATUS='NEW',ERR=999)
      ERRMSG='WRITING FILE'
      IF(IDEB.NE.1) WRITE(6,997) ERRMSG
      WRITE(NUNIT,124,ERR=999) TEXT,NSKIP
124   FORMAT(A50,I5,' lines+(Q, I(Q), errI(Q))' )
c                    1234567890123456789012345678901234567890
      IF(IREF.EQ.1) WRITE(NUNIT,125,ERR=999) KEY,INST(1:3)
125   FORMAT(A4,' SANS',1X,A3,'  ')
      IF(IREF.NE.1) WRITE(NUNIT,126,ERR=999) KEY,INST(1:3)
126   FORMAT(A4,' REFX',1X,A3,'  ')
      WRITE(NUNIT,123) IRUN,IRUNX,NDATA,NTOTD2,NSKIP1,NPDF
      WRITE(NUNIT,123) IVERS,NTXT,NPAR,NPARX,LPDF,IERRS
c***** RSIO and GRUNDD can set GRDD, unlikely by chance...
      IF(GRDD(5:8).EQ.'MASK') MINRME='MASK: '//MFNAME(1:23)
      WRITE(NUNIT,28,ERR=999) XPNAM,DATIM,MINRME
      IF(NTXT.GT.0) WRITE(NUNIT,27,ERR=999) (XTXT(I),I=1,NTXT)
c***** check values are printable
      DO 150 I=1,NPAR
      PARR(I)=PAR(I)
      IF(I.EQ.9.OR.I.EQ.10) go to 150
      IF(PAR(I).GT.99999.) PARR(I)= 99999.99
      IF(PAR(I).LT.-99999.) PARR(I)=-9999.99
150   CONTINUE
      IF(PARR(9).LT.0) PARR(9)=0.
      IF(PARR(10).LT.-99999999) PARR(10)=0  
      IF(PARR(9).GT. 999999999.)  PARR(9)=999999999.
      IF(PARR(10).GT.999999999.) PARR(10)=999999999.
      WRITE(NUNIT,131,ERR=999) (PARR(I),PARTIT(I),I=1,NPAR)
131   FORMAT(8(F10.4,' ! ',A/),2(F10.0,' ! ',A/),(F10.4,' ! ',A))
      IF(NPARX.GT.0) WRITE(NUNIT,41,ERR=999) (PARX(I),I=1,NPARX)
      IF(LPDF.GT.0) WRITE(NUNIT,45,ERR=999) IC
      IF(LPDF.GT.0) WRITE(NUNIT,46,ERR=999) R
      WRITE(NUNIT,57,ERR=999) (Q(I),S(I),ES(I),I=1,NDATA)
      CLOSE(NUNIT)
      EXTCMD=' '
      IF(IEXCMD.NE.0) EXTCMD=EXTENV(1:IEXCMD+1)//FNAME
      IF(IEXCMD.NE.0) CALL SYSTEM(EXTCMD)
      IERR=0
      RETURN
999   WRITE(6,998) ERRMSG,FNAME
998   FORMAT(/' RGIO: ERROR - INVALID - ',A,/
     1' CURRENTLY READING/WRITING : ',A)
      CLOSE(NUNIT)
990   WRITE(6,989) IRUN,IRUNX
989   FORMAT(' No data found for run' ,i6,'  ext.',i4)
      CLOSE(NUNIT)
      RETURN
      END
      BLOCK DATA RGIOB
      COMMON/RGIOY/NUNIT,INTTY
      COMMON/RGIOC/XTXT(10)
      COMMON/RGIOD/PARTIT(40)
      COMMON/RGIOR/PARTIR(40)
      COMMON/RGIOS/PARTIS(40)
      COMMON/RGIOP/PARX(20)
      COMMON/RGIOX/NTXT,NPARX
      COMMON/RGIOI/XPNAM,DATIM
      COMMON/RGIOL/NDIM,LIMDAT,LIMTXT,LIMPX,IONCE
      COMMON/RGINST/INST
      CHARACTER*30 PARTIT,PARTIS,PARTIR
      CHARACTER*80 XTXT
      CHARACTER*20 DATIM
      CHARACTER*4 XPNAM,INST
      SAVE
      DATA NUNIT/32/,INTTY/6/
      DATA XTXT/10*'                                                 '/
      DATA PARX/20*0.0/
      DATA NTXT/0/,NPARX/0/
      DATA NDIM/1/,LIMDAT/180/,LIMTXT/10/,LIMPX/20/,IONCE/0/
      DATA INST/'    '/
      DATA PARTIS/
     1'Theta-0 Detector offset angle ',
     1'X0 cms Beam centre            ',
     1'Y0 cms Beam centre            ',
     1'Delta-R cms regrouping step   ',
     1'SD m Sample-detector distance ',
     1'Angstroms incident wavelength ',
     1'm collimation distance        ',
     1'concentration                 ',
     1'ISUM central window sum       ',
     1'flux monitor counts           ',
     1'degrees detector sector width ',
     1'degrees sector orientation    ',
     1'% FWHM_wavelength spread      ',
     1'mm source slit width x        ',
     1'mm source slit height y       ',
     1'mm sample width x             ',
     1'mm sample height y            ',
     1'mm detector x pixel size      ',
     1'mm detector y pixel size      ',
     1'degrees sample normal/beam    ',
     1'K sample temperature          ',
     1'sample transmission           ',
     1'mm sample thickness           ',
     1'counting time secs            ',
     1'reserved                      ',
     1'reserved                      ',
     1'reserved                      ',
     1'reserved                      ',
     1'reserved                      ',
     1'reserved                      ',
     1'reserved                      ',
     1'reserved                      ',
     18*'                              '/
      DATA PARTIR/
     1'Theta-0 Detector offset angle ',
     1'X0 cms Beam centre            ',
     1'Y0 cms Beam centre            ',
     1'S2_S m Slit2-sample distance  ',
     1'SD m Sample-detector distance ',
     1'Angstroms incident wavelength ',
     1'm collimation S1_S2 distance  ',
     1'concentration                 ',
     1'ISUM central window sum       ',
     1'flux monitor counts           ',
     1'mm S1_width x  (if fixed)     ',
     1'mm S1_height y                ',
     1'% wavelength spread           ',
     1'mm S2_width x  (if fixed)     ',
     1'mm S2_height y                ',
     1'mm sample width x             ',
     1'mm sample height y            ',
     1'mm detector x pixel size      ',
     1'mm detector y pixel size      ',
     1'                              ',
     1'K sample temperature          ',
     1'                              ',
     1'                              ',
     1'counting time secs            ',
     1'reserved                      ',
     1'reserved                      ',
     1'reserved                      ',
     1'reserved                      ',
     1'reserved                      ',
     1'reserved                      ',
     1'reserved                      ',
     1'reserved                      ',
     18*'                              '/
      END      
